﻿<?php
/*
	Default Profile Plugin
	
	Gives new users who register a default avatar, signature, profile.
	For MyBB 1.6.x.
	
	Copyright © 2006 - 2011 Dennis Tsang (http://dennistt.net)and Conor Calby (http://shockinghost.com)
	
	==========
	LICENSE
	==========
	This plugin by Dennis Tsang and updated by Conor Calby is licensed under the
	Creative Commons Attribution-No Derivative Works 2.5 Canada License
	
	Summary: http://creativecommons.org/licenses/by-nd/2.5/ca/
	Legal Code: http://creativecommons.org/licenses/by-nd/2.5/ca/legalcode.en
	
	A summary follows for convenience:
	
	You are free:
		To use the software
		To share -- to copy, distribute and transmit the work as the original whole

	Under the following conditions:
		Attribution.  You must attribute the work in the manner specified by the author or licensor (but not in any way that suggests that they endorse you or your use of the work).  All author and copyright notices must be left intact at ALL times while using the software, and in any redistributed package.
		No Derivative Works.  You may not release altered, transformed, or otherwise modified versions of this work.  However, you may modify the software for use on your forum only.  Translations must be done using external .lang.php files.
		
	- For any reuse or distribution, you must make clear to others the licence terms of this work.
	- The author's moral rights are retained in this licence.

*/

if(!defined("IN_MYBB"))
{
	die("Direct initialization of this file is not allowed.<br /><br />Please make sure IN_MYBB is defined.");
}

function defaultprofile_info()
{
	global $lang;
	defaultprofile_load_language();
	
	return array(
		"name"			=> $lang->defaultprofile,
		"description"	=> $lang->defaultprofile_desc,
		"website"		=> "http://www.dennistt.net",
		"author"		=> "DennisTT & Conor Calby",
		"authorsite"	=> "http://www.mybb.com",
		"version"		=> "2.0",
		"guid"			  => "94c45014770d938ae5217c534bb9417f",
		"compatibility"   => "16*",
		
		// DennisTT custom info
		"codename" => 'defaultprofile',
	);
}

// Helper function to load the language variables
function defaultprofile_load_language()
{
	global $lang;
	if(!defined('DENNISTT_DEFAULTPROFILE_LANG_LOADED'))
	{
		$lang->load('defaultprofile', false, true);
		
		if(!isset($lang->defaultprofile))
		{
			$lang->defaultprofile = 'پروفایل پیشفرض';
			$lang->defaultprofile_desc = 'تنظیمات پیشفرض پروفایل مانند آواتار، امضا و سایر تنظیمات برای کاربر های تازه عضو شده، فارسی سازی توسط MyBBIran.com';
			
		}
		
		define('DENNISTT_DEFAULTPROFILE_LANG_LOADED', 1);
	}
}

function defaultprofile_activate()
{
	global $db;
	$info = defaultprofile_info();
	
	// Remove old plugin stuff
	defaultprofile_deactivate();

	$setting_group_array = array(
		'name' => str_replace(' ', '_', 'dennistt_'.strtolower($info['codename'])),
		'title' => "$info[name]",
		'description' => "تنظیمات پلاگین $info[name]",
		'disporder' => 1,
		'isdefault' => '0',
		);
	$db->insert_query('settinggroups', $setting_group_array);
	$group = $db->insert_id();

	$settings = array(
		'defaultprofile_avatar' => array('لینک آواتار', 'لینک پیشفرض آواتار (نمونه: images/avatars/php.gif یا http://anothersite.com/someimage.gif)', 'text', './images/avatars/php.gif'),
		'defaultprofile_signature' => array('امضا', 'این قسمت برای امضای پیشفرض پروفایل می باشد.<br /><br />کد های زیر قابل استفاده هستند:<br />{username} - نام کاربری<br />{regdate} - تاریخ ثبت نام<br />{bbname} - نام انجمن', 'textarea', '{username}، از تاریخ {regdate} عضو {bbname} می باشد.'),
		'defaultprofile_additionalgroups' => array('گروه های کاربری اضافی', 'ID گروه کاربری که کاربر باید عضوی از آن باشد. (برای جدا کردن از کاما استفاده کنید)', 'text', ''),
		'defaultprofile_website' => array('لینک سایت', 'لینک پیشفرض وبسایت کاربر', 'text', ''),
		'defaultprofile_showsigs' => array('نمایش امضا', 'امضای کاربر ها در ارسال هایشان نمایش داده شود؟', 'yesno', '1'),
		'defaultprofile_showavatars' => array('نمایش آواتار', 'آواتار کاربر ها در ارسال هایشان نمایش داده شود؟', 'yesno', '1'),
		'defaultprofile_showquickreply' => array('نمایش پاسخ سریع', 'پاسخ سریع در موضوع ها نمایش داده شود؟', 'yesno', '0'),
		'defaultprofile_showredirect' => array('نمایش راهنمای دوستانه', 'صفحه راهنمای دوستانه نمایش داده شود؟', 'yesno', '1'),
		'defaultprofile_tpp' => array('تعداد موضوع ها در هر صفحه', 'تعداد موضوع هایی که در هر صفحه نمایش داده می شوند. عدد صفر \'0\' را برای پیروی از تنظیمات انجمن وارد کنید.', 'text', '0'),
		'defaultprofile_ppp' => array('تعداد ارسال ها در هر صفحه', 'تعداد ارسال هایی که در هر صفحه نمایش داده می شوند. عدد صفر \'0\' را برای پیروی از تنظیمات انجمن وارد کنید.', 'text', '0'),
		'defaultprofile_style' => array('نوع پوسته', 'ID پوسته مورد نظر برای کاربر های جدید را وارد کنید. عدد صفر \'0\' را برای پیروی از تنظیمات انجمن وارد کنید.', 'text', '0'),
		'defaultprofile_threadmode' => array('نمایش به صورت موضوع بندی؟', 'برای استفاده از حالت موضوع بندی \'yes\' و برای استفاده از حالت خطی \'no\' را انتخاب کنید.', 'yesno', '0'),
		'defaultprofile_daysprune' => array('محدود کردن نمایش موضوع ها', 'نمایش موضوع ها از روز X و بعد از آن. عدد صفر \'0\' را برای پیروی از تنظیمات انجمن وارد کنید. \'all\' را برای نمایش تمامی موضوع ها بدون در نظر گرفتن تاریخ وارد کنید.', 'text', 'all'),
		'defaultprofile_notepad' => array('یادداشت کاربر', 'محتویات یادداشت', 'textarea', ''),
		'defaultprofile_classicpostbit' => array('از پست بیت کلاسیک استفاده شود؟', 'پست بیت کلاسیک همان پست بیت عمودی می باشد.', 'yesno', '0'),
		);

	$i = 1;
	foreach($settings as $name => $sinfo)
	{
		$insert_array = array(
			'name' => $name,
			'title' => $db->escape_string($sinfo[0]),
			'description' => $db->escape_string($sinfo[1]),
			'optionscode' => $db->escape_string($sinfo[2]),
			'value' => $db->escape_string($sinfo[3]),
			'gid' => $group,
			'disporder' => $i,
			'isdefault' => 0,
			);
		$db->insert_query('settings', $insert_array);
		$i++;
	}
	rebuild_settings();
}

function defaultprofile_deactivate()
{
	global $db;
	$info = defaultprofile_info();
	$result = $db->simple_select('settinggroups', 'gid', "name = '".str_replace(' ', '_', 'dennistt_'.strtolower($info['codename']))."'", array('limit' => 1));
	$group = $db->fetch_array($result);
	
	if(!empty($group['gid']))
	{
		$db->delete_query('settinggroups', "gid='{$group['gid']}'");
		$db->delete_query('settings', "gid='{$group['gid']}'");
		rebuild_settings();
	}
}

$plugins->add_hook("member_do_register_start", "defaultprofile_register_start");
function defaultprofile_register_start()
{
	define('DEFAULTPROFILE_REGISTERING', true);
}

$plugins->add_hook("datahandler_user_insert", "defaultprofile_insert");
function defaultprofile_insert($user)
{
	global $db, $mybb;
	if(defined('DEFAULTPROFILE_REGISTERING'))
	{
		if(!empty($mybb->settings['defaultprofile_avatar']))
		{
			$user->user_insert_data['avatar'] = $db->escape_string($mybb->settings['defaultprofile_avatar']);
			$user->user_insert_data['avatartype'] = 'remote';
		}
		if(!empty($mybb->settings['defaultprofile_signature']))
		{
			$default_signature = $mybb->settings['defaultprofile_signature'];
			$default_signature = str_replace("{username}", $user->user_insert_data['username'], $default_signature);
			$default_signature = str_replace("{regdate}", date($mybb->settings['regdateformat'], time()), $default_signature);
			$default_signature = str_replace("{bbname}", $mybb->settings['bbname'], $default_signature);
			$user->user_insert_data['signature'] = $db->escape_string($default_signature);
		}
		if(!empty($mybb->settings['defaultprofile_additionalgroups']))
		{
			$user->user_insert_data['additionalgroups'] = $db->escape_string($mybb->settings['defaultprofile_additionalgroups']);
		}
		if(!empty($mybb->settings['defaultprofile_website']))
		{
			$user->user_insert_data['website'] = $db->escape_string($mybb->settings['defaultprofile_website']);
		}
		if($mybb->settings['defaultprofile_showsigs'] == 1)
		{
			$user->user_insert_data['showsigs'] = 1;
		}
		else
		{
			$user->user_insert_data['showsigs'] = 0;
		}
		if($mybb->settings['defaultprofile_showavatars'] == 1)
		{
			$user->user_insert_data['showavatars'] = 1;
		}
		else
		{
			$user->user_insert_data['showavatars'] = 0;
		}
		if($mybb->settings['defaultprofile_showquickreply'] == 1)
		{
			$user->user_insert_data['showquickreply'] = 1;
		}
		else
		{
			$user->user_insert_data['showquickreply'] = 0;
		}
		if($mybb->settings['defaultprofile_showredirect'] == 1)
		{
			$user->user_insert_data['showredirect'] = 1;
		}
		else
		{
			$user->user_insert_data['showredirect'] = 0;
		}
		if(!empty($mybb->settings['defaultprofile_tpp']))
		{
			$user->user_insert_data['tpp'] = intval($mybb->settings['defaultprofile_tpp']);
		}
		if(!empty($mybb->settings['defaultprofile_ppp']))
		{
			$user->user_insert_data['ppp'] = intval($mybb->settings['defaultprofile_ppp']);
		}
		if(!empty($mybb->settings['defaultprofile_style']))
		{
			$user->user_insert_data['style'] = intval($mybb->settings['defaultprofile_style']);
		}
		if($mybb->settings['defaultprofile_threadmode'] == 'yes')
		{
			$user->user_insert_data['threadmode'] = 'threaded';
		}
		else
		{
			$user->user_insert_data['threadmode'] = 'linear';
		}
		if(!empty($mybb->settings['defaultprofile_daysprune']))
		{
			$user->user_insert_data['daysprune'] = intval($mybb->settings['defaultprofile_daysprune']);
		}
		if(!empty($mybb->settings['defaultprofile_notepad']))
		{
			$user->user_insert_data['notepad'] = $db->escape_string($mybb->settings['defaultprofile_notepad']);
		}
		if($mybb->settings['defaultprofile_classicpostbit'] == 1)
		{
			$user->user_insert_data['classicpostbit'] = 1;
		}
		else
		{
			$user->user_insert_data['classicpostbit'] = 0;
		}
	}
}
?>